using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

namespace MDXLibrary.DXGraphics
{
    #region    񋓌^

    /// <summary>
    /// eNX`╶`̍ۂ̕@B
    /// </summary>
    public enum MDXDrawMode { 
        /// <summary>ʏ</summary>
        Normal,

        /// <summary>E]</summary>
        LRInvert,

        /// <summary>㉺]</summary>
        TDInvert
    };

    #endregion 񋓌^

    /// <summary>
    /// OtBbN`悷邽߂̃NXB
    /// Direct3DpBłQc`̂݁B
    /// </summary>
    public class MDXGraphics:IDisposable
    {

        #region    IuWFNg

        #region    J

        public System.Windows.Forms.Control    Control;            //eRg[
        public Device                          Device;             //foCX
        public Sprite                          Sprite;             //XvCg
        public PresentParameters               PParamFullScreen;   //ʃ[h
        public PresentParameters               PParamWindow;       //ʃ[h
        public Microsoft.DirectX.Direct3D.Font Font;               //tHg

        #endregion J


        #region    lp``p

        private CustomVertex.TransformedColoredTextured[] RectVert;       //lp``p_
        private VertexBuffer                              RectVertBuffer; //lp``p_obt@

        #endregion lp``p


        #region    XvCg`p

        private bool               SpriteTransformFlag       = true;
        private MDXDrawMode        SpriteDrawMode            = MDXDrawMode.Normal;
        private Matrix             SpriteDrawMatrix_Normal   = Matrix.Identity;
        private Matrix             SpriteDrawMatrix_LRInvert = Matrix.RotationY((float)-Math.PI);
        private Matrix             SpriteDrawMatrix_TDInvert = Matrix.RotationX((float) Math.PI);
        private Vector2            V2Empty = Vector2.Empty;
        private Vector2            V2Tmp1  = new Vector2();
        private Vector3            V3Empty = Vector3.Empty;
        private Vector3            V3Tmp1  = new Vector3();
        private Vector3            V3Tmp2  = new Vector3();

        #endregion XvCg`p

        #endregion IuWFNg


        #region    \bh

        #region    RXgN^

        /// <summary>
        /// RXgN^B
        /// </summary>
        /// <param name="cControl">eB</param>
        public MDXGraphics(System.Windows.Forms.Control cControl):this(cControl,-1,-1,-1,true)
        {
        }

        /// <summary>
        /// RXgN^B
        /// </summary>
        /// <param name="cControl"    >eB</param>
        /// <param name="iWidth"      >B</param>
        /// <param name="iHeight"     >B</param>
        /// <param name="iRefreshRate">tbV[gB</param>
        /// <param name="bWindowed"   >\[hitrue:EChE\, false:tXN[\j</param>
        public MDXGraphics(System.Windows.Forms.Control cControl, int iWidth, int iHeight, int iRefreshRate, bool bWindowed)
        {
            this.Control = cControl;

            //foCXݒiEChE[hpj
            PParamWindow                      = new PresentParameters();
            PParamWindow.Windowed             = true;
            PParamWindow.SwapEffect           = SwapEffect.Discard;
            PParamWindow.PresentationInterval = PresentInterval.Immediate;
            if (iWidth > 0)
            {
                int iTmp = iWidth - this.Control.Width;
                this.Control.Width = iWidth;
                this.Control.Left -= iTmp / 2;
                if (this.Control.Left < 0) this.Control.Left = 0;
            }
            if (iHeight > 0)
            {
                int iTmp = iHeight - this.Control.Height;
                this.Control.Height = iHeight;
                this.Control.Top -= iTmp / 2;
                if (this.Control.Top < 0) this.Control.Top = 0;
            }

            //foCXݒitXN[[hpj
            PParamFullScreen                      = new PresentParameters();
            PParamFullScreen.Windowed             = false;
            PParamFullScreen.SwapEffect           = SwapEffect.Discard;
            PParamFullScreen.PresentationInterval = PresentInterval.Immediate;

            bool bNotFound = true;
            foreach (DisplayMode dm in Manager.Adapters[0].SupportedDisplayModes)
            {
                if (dm.Width == iWidth && dm.Height == iHeight && dm.RefreshRate == iRefreshRate)
                {
                    PParamFullScreen.FullScreenRefreshRateInHz = iRefreshRate;
                    PParamFullScreen.BackBufferWidth           = iWidth;
                    PParamFullScreen.BackBufferHeight          = iHeight;
                    PParamFullScreen.BackBufferFormat          = dm.Format;
                    bNotFound = false;
                    break;
                }
            }
            if (bNotFound && !bWindowed)
            {
                System.Windows.Forms.MessageBox.Show("w肳ꂽfBXvC[h݂܂łB");
                return;
            }


            //foCXݒ
            try
            {
                this.Device = new Device(0, DeviceType.Hardware, this.Control, CreateFlags.HardwareVertexProcessing, bWindowed ? PParamWindow : PParamFullScreen);
                System.Console.WriteLine("MDXGraphics : HardwareVertexProcessing");
            }
            catch (InvalidCallException)
            {
                this.Device = new Device(0, DeviceType.Hardware, cControl, CreateFlags.SoftwareVertexProcessing, bWindowed ? PParamWindow : PParamFullScreen);
                System.Console.WriteLine("MDXGraphics : SoftwareVertexProcessing");
            }

            //  /* v!!!!!!!!!!!!!
            this.Device.RenderState.CullMode         = Cull.None;
            this.Device.RenderState.Lighting         = false;
            this.Device.RenderState.AlphaBlendEnable = true;
            this.Device.RenderState.SourceBlend      = Blend.SourceAlpha;
            this.Device.RenderState.DestinationBlend = Blend.InvSourceAlpha;
            this.Device.SetTextureStageState(0, TextureStageStates.AlphaOperation, (int)TextureOperation.Modulate);
            this.Device.SetTextureStageState(0, TextureStageStates.AlphaArgument1, (int)TextureArgument.TextureColor);
            this.Device.SetTextureStageState(0, TextureStageStates.AlphaArgument2, (int)TextureArgument.Current);
            //     v!!!!!!!!!!!!!*/


            //lp``p_E_obt@
            this.RectVert = new CustomVertex.TransformedColoredTextured[4];
            this.RectVertBuffer = new VertexBuffer(
                typeof(CustomVertex.TransformedColoredTextured),
                this.RectVert.Length,
                this.Device,
                Usage.None,
                CustomVertex.TransformedColoredTextured.Format,
                Pool.Managed
            );


            //XvCg
            this.Sprite = new Sprite(this.Device);


            //tHg
            FontDescription fd = new FontDescription();
            fd.Height   = 16;
            fd.FaceName = "lr SVbN";
            this.Font = new Microsoft.DirectX.Direct3D.Font(this.Device, fd);
        }

        #endregion RXgN^


        #region    `搧

        /// <summary>
        /// `̊JnB
        /// `֘Å֐ĂԑOɂ̊֐ĂłKvB
        /// BeginScene???Draw???Draw...EndScenePresent
        /// </summary>
        public void BeginScene()
        {
            this.Device.BeginScene();
        }

        /// <summary>
        /// `̏IB
        /// </summary>
        public void EndScene()
        {
            this.Device.EndScene();
        }

        /// <summary>
        /// `eۂɃfBXvCɕ\B
        /// </summary>
        public void Present()
        {
            try
            {
                this.Device.Present();
            }
            catch (DeviceLostException)
            {
                while (true)
                {
                    if (this.Control.Focused)
                    {
                        this.Device.Reset(PParamFullScreen);
                        break;
                    }
                    else
                    {
                        System.Threading.Thread.Sleep(1000);
                        System.Windows.Forms.Application.DoEvents();
                    }
                }
            }
        }

        /// <summary>
        /// XvCg`̊JnB
        /// XvCg֘Å֐ĂԑOɂ̊֐ĂłKvB
        /// ܂AXvCg֘A̕`悪ISpriteEndĂԕKvB
        /// </summary>
        /// <param name="sfFlag">XvCg`̕@</param>
        public void SpriteBegin(SpriteFlags sfFlag)
        {
            this.Sprite.Begin(sfFlag);
        }

        /// <summary>
        /// XvCg`̏IB
        /// </summary>
        public void SpriteEnd()
        {
            this.Sprite.End();
        }

        /// <summary>
        /// EChE[hؑ
        /// </summary>
        /// <param name="bWindowed">true:EChE\, false:tXN[\</param>
        public void ChangeWindowMode(bool bWindowed)
        {
            System.Threading.Thread.Sleep(500);
            System.Windows.Forms.Application.DoEvents();

            if (bWindowed)
            {
                this.Device.Reset(PParamWindow);
            }
            else
            {
                this.Device.Reset(PParamFullScreen);
            }

            System.Threading.Thread.Sleep(500);
            System.Windows.Forms.Application.DoEvents();
        }

        #endregion `搧


        #region    `揈

        /// <summary>
        /// ʂNAB
        /// </summary>
        /// <param name="iColor"></param>
        public void Clear(int iColor)
        {
            this.Device.Clear(ClearFlags.Target, iColor, 1.0f, 0);
        }

        /// <summary>
        /// lp``悷B
        /// </summary>
        /// <param name="iX1"       >㒸_XW</param>
        /// <param name="iY1"       >㒸_YW</param>
        /// <param name="iX2"       >E㒸_XW</param>
        /// <param name="iY2"       >E㒸_YW</param>
        /// <param name="iX3"       >_XW</param>
        /// <param name="iY3"       >_YW</param>
        /// <param name="iX4"       >E_XW</param>
        /// <param name="iY4"       >E_YW</param>
        /// <param name="iColor1"   >㒸_J[</param>
        /// <param name="iColor2"   >E㒸_J[</param>
        /// <param name="iColor3"   >_J[</param>
        /// <param name="iColor4"   >E_J[</param>
        /// <param name="mdxTexture">eNX`Bnull̏ꍇ̓eNX`ȂB</param>
        public void RectDraw(int iX1, int iY1, int iX2, int iY2, int iX3, int iY3, int iX4, int iY4, int iColor1, int iColor2, int iColor3, int iColor4, MDXTexture mdxTexture)
        {
            RectVert[0].X = iX1;
            RectVert[0].Y = iY1;
            RectVert[0].Z = 0f;
            RectVert[0].Tu = 0f;
            RectVert[0].Tv = 0f;
            RectVert[0].Rhw = 1f;
            RectVert[0].Color = iColor1;
            RectVert[1].X = iX2;
            RectVert[1].Y = iY2;
            RectVert[1].Z = 0f;
            RectVert[1].Tu = 1f;
            RectVert[1].Tv = 0f;
            RectVert[1].Rhw = 1f;
            RectVert[1].Color = iColor2;
            RectVert[2].X = iX3;
            RectVert[2].Y = iY3;
            RectVert[2].Z = 0f;
            RectVert[2].Tu = 0f;
            RectVert[2].Tv = 1f;
            RectVert[2].Rhw = 1f;
            RectVert[2].Color = iColor3;
            RectVert[3].X = iX4;
            RectVert[3].Y = iY4;
            RectVert[3].Z = 0f;
            RectVert[3].Tu = 1f;
            RectVert[3].Tv = 1f;
            RectVert[3].Rhw = 1f;
            RectVert[3].Color = iColor4;

            //eNX`[̐ݒ
            Device.SetTexture(0, mdxTexture == null ? null : mdxTexture.Texture);

            //_𒸓_obt@ɏ
            GraphicsStream gs = RectVertBuffer.Lock(0, 0, 0);
            gs.Write(RectVert);
            RectVertBuffer.Unlock();

            //foCXɏݗp_obt@Zbg
            Device.SetStreamSource(0, RectVertBuffer, 0);
            Device.VertexFormat = CustomVertex.TransformedColoredTextured.Format;

            //`
            Device.DrawPrimitives(PrimitiveType.TriangleStrip, 0, 2);
        }

        /// <summary>
        /// lp``悷Blp`̃TCY̓eNX`̃TCYB
        /// </summary>
        /// <param name="iX"        >lp`̒SXW</param>
        /// <param name="iY"        >lp`̒SYW</param>
        /// <param name="iColor"    >lp`̐F</param>
        /// <param name="mdxTexture">eNX`B</param>
        public void RectDraw(int iX, int iY, int iColor, MDXTexture mdxTexture)
        {
            int iHalfW = mdxTexture.Width / 2;
            int iHalfH = mdxTexture.Height / 2;
            RectDraw(
                iX - iHalfW,
                iY - iHalfH,
                iX + iHalfW,
                iY - iHalfH,
                iX - iHalfW,
                iY + iHalfH,
                iX + iHalfW,
                iY + iHalfH,
                iColor,
                iColor,
                iColor,
                iColor,
                mdxTexture
            );
        }

        /// <summary>
        /// lp``悷Blp`̃TCY̓eNX`̃TCYB
        /// </summary>
        /// <param name="iX"        >lp`̒SXW</param>
        /// <param name="iY"        >lp`̒SYW</param>
        /// <param name="iColor1"   >㒸_J[</param>
        /// <param name="iColor2"   >E㒸_J[</param>
        /// <param name="iColor3"   >_J[</param>
        /// <param name="iColor4"   >E_J[</param>
        /// <param name="mdxTexture">eNX`B</param>
        public void RectDraw(int iX, int iY, int iColor1, int iColor2, int iColor3, int iColor4, MDXTexture mdxTexture)
        {
            int iHalfW = mdxTexture.Width / 2;
            int iHalfH = mdxTexture.Height / 2;
            RectDraw(
                iX - iHalfW,
                iY - iHalfH,
                iX + iHalfW,
                iY - iHalfH,
                iX - iHalfW,
                iY + iHalfH,
                iX + iHalfW,
                iY + iHalfH,
                iColor1,
                iColor2,
                iColor3,
                iColor4,
                mdxTexture
            );
        }

        /// <summary>
        /// lp``悷B
        /// </summary>
        /// <param name="iX"        >lp`̒SXW</param>
        /// <param name="iY"        >lp`̒SYW</param>
        /// <param name="iW"        >lp`̉</param>
        /// <param name="iH"        >lp`̍</param>
        /// <param name="iColor"    >lp`̐F</param>
        /// <param name="mdxTexture">eNX`Bnull̏ꍇ̓eNX`ȂB</param>
        public void RectDraw(int iX, int iY, int iW, int iH, int iColor, MDXTexture mdxTexture)
        {
            int iHalfW = iW / 2;
            int iHalfH = iH / 2;
            RectDraw(
                iX - iHalfW,
                iY - iHalfH,
                iX + iHalfW,
                iY - iHalfH,
                iX - iHalfW,
                iY + iHalfH,
                iX + iHalfW,
                iY + iHalfH,
                iColor,
                iColor,
                iColor,
                iColor,
                mdxTexture
            );
        }

        /// <summary>
        /// lp``悷B
        /// </summary>
        /// <param name="iX"        >lp`̒SXW</param>
        /// <param name="iY"        >lp`̒SYW</param>
        /// <param name="iW"        >lp`̉</param>
        /// <param name="iH"        >lp`̍</param>
        /// <param name="iColor1"   >㒸_J[</param>
        /// <param name="iColor2"   >E㒸_J[</param>
        /// <param name="iColor3"   >_J[</param>
        /// <param name="iColor4"   >E_J[</param>
        /// <param name="mdxTexture">eNX`Bnull̏ꍇ̓eNX`ȂB</param>
        public void RectDraw(int iX, int iY, int iW, int iH, int iColor1, int iColor2, int iColor3, int iColor4, MDXTexture mdxTexture)
        {
            int iHalfW = iW / 2;
            int iHalfH = iH / 2;
            RectDraw(
                iX - iHalfW,
                iY - iHalfH,
                iX + iHalfW,
                iY - iHalfH,
                iX - iHalfW,
                iY + iHalfH,
                iX + iHalfW,
                iY + iHalfH,
                iColor1,
                iColor2,
                iColor3,
                iColor4,
                mdxTexture
            );
        }


        /// <summary>
        /// XvCg`悷B
        /// </summary>
        /// <param name="iX"        >XvCg̒SXWifBXvC̕`悳ʒuj</param>
        /// <param name="iY"        >XvCg̒SYWifBXvC̕`悳ʒuj</param>
        /// <param name="fCw"       >eNX`̒S̉ʒui0[A0.5^񒆁A1E[j</param>
        /// <param name="fCh"       >eNX`̒S̏cʒui0[A0.5^񒆁A1[j</param>
        /// <param name="fZoom"     >g嗦(0.5:A1:̂܂܁A2:{)</param>
        /// <param name="fAngle"    >]px(0:̂܂)</param>
        /// <param name="iColor"    >FB̂܂܂̐F̏ꍇ-1B</param>
        /// <param name="mdxTexture">eNX`B</param>
        public void SpriteDraw(int iX, int iY, float fCw, float fCh, float fZoom, float fAngle, int iColor, MDXTexture mdxTexture)
        {
            V2Tmp1.X = iX; V2Tmp1.Y = iY;
            Sprite.Transform = Matrix.AffineTransformation2D(fZoom, V2Empty, fAngle, V2Tmp1);
            V3Tmp1.X = mdxTexture.Width * fCw; V3Tmp1.Y = mdxTexture.Height * fCh; V3Tmp1.Z = 0.0f;
            Sprite.Draw(mdxTexture.Texture, V3Tmp1, V3Empty, iColor);
            SpriteTransformFlag = true;
        }

        /// <summary>
        /// XvCg`悷B
        /// </summary>
        /// <param name="iX"         >XvCg̒SXWifBXvC̕`悳ʒuj</param>
        /// <param name="iY"         >XvCg̒SYWifBXvC̕`悳ʒuj</param>
        /// <param name="fCw"        >eNX`̒S̉ʒui0[A0.5^񒆁A1E[j</param>
        /// <param name="fCh"        >eNX`̒S̏cʒui0[A0.5^񒆁A1[j</param>
        /// <param name="fZoom"      >g嗦(0.5:A1:̂܂܁A2:{)</param>
        /// <param name="fAngle"     >]px(0:̂܂)</param>
        /// <param name="iColor"     >FB̂܂܂̐F̏ꍇ-1B</param>
        /// <param name="mdxTexture" >eNX`B</param>
        /// <param name="mdxDrawMode">\@B</param>
        public void SpriteDraw(int iX, int iY, float fCw, float fCh, float fZoom, float fAngle, int iColor, MDXTexture mdxTexture, MDXDrawMode mdxDrawMode)
        {
            switch (mdxDrawMode)
            {
                case MDXDrawMode.Normal:
                    V2Tmp1.X = iX; V2Tmp1.Y = iY;
                    Sprite.Transform = Matrix.AffineTransformation2D(fZoom, V2Empty, fAngle, V2Tmp1);
                    V3Tmp1.X = mdxTexture.Width * fCw; V3Tmp1.Y = mdxTexture.Height * fCh; V3Tmp1.Z = 0.0f;
                    Sprite.Draw(mdxTexture.Texture, V3Tmp1, V3Empty, iColor);
                    break;

                case MDXDrawMode.LRInvert:
                    V2Tmp1.X = -iX; V2Tmp1.Y = iY;
                    Sprite.Transform = Matrix.AffineTransformation2D(fZoom, V2Empty, -fAngle, V2Tmp1) * SpriteDrawMatrix_LRInvert;
                    V3Tmp1.X = mdxTexture.Width * fCw; V3Tmp1.Y = mdxTexture.Height * fCh; V3Tmp1.Z = 0.0f;
                    Sprite.Draw(mdxTexture.Texture, V3Tmp1, V3Empty, iColor);
                    break;

                case MDXDrawMode.TDInvert:
                    V2Tmp1.X = iX; V2Tmp1.Y = -iY;
                    Sprite.Transform = Matrix.AffineTransformation2D(fZoom, V2Empty, -fAngle, V2Tmp1) * SpriteDrawMatrix_TDInvert;
                    V3Tmp1.X = mdxTexture.Width * fCw; V3Tmp1.Y = mdxTexture.Height * fCh; V3Tmp1.Z = 0.0f;
                    Sprite.Draw(mdxTexture.Texture, V3Tmp1, V3Empty, iColor);
                    break;
            }
            SpriteTransformFlag = true;
        }

        /// <summary>
        /// XvCg`悷B
        /// </summary>
        /// <param name="iX"         >XvCg̒SXWifBXvC̕`悳ʒuj</param>
        /// <param name="iY"         >XvCg̒SYWifBXvC̕`悳ʒuj</param>
        /// <param name="fCw"        >eNX`̒S̉ʒui0[A0.5^񒆁A1E[j</param>
        /// <param name="fCh"        >eNX`̒S̏cʒui0[A0.5^񒆁A1[j</param>
        /// <param name="iColor"     >FB̂܂܂̐F̏ꍇ-1B</param>
        /// <param name="mdxTexture" >eNX`B</param>
        public void SpriteDraw(int iX, int iY, float fCw, float fCh, int iColor, MDXTexture mdxTexture)
        {
            if (SpriteTransformFlag || SpriteDrawMode != MDXDrawMode.Normal) //ʂȏ炷
            {
                Sprite.Transform = SpriteDrawMatrix_Normal;
                SpriteTransformFlag = false;
                SpriteDrawMode = MDXDrawMode.Normal;
            }
            V3Tmp1.X = mdxTexture.Width * fCw; V3Tmp1.Y = mdxTexture.Height * fCh; V3Tmp1.Z = 0.0f;
            V3Tmp2.X = iX; V3Tmp2.Y = iY; V3Tmp2.Z = 0.0f;
            Sprite.Draw(mdxTexture.Texture, V3Tmp1, V3Tmp2, iColor);
        }

        /// <summary>
        /// XvCg`悷B
        /// </summary>
        /// <param name="iX"         >XvCg̒SXWifBXvC̕`悳ʒuj</param>
        /// <param name="iY"         >XvCg̒SYWifBXvC̕`悳ʒuj</param>
        /// <param name="fCw"        >eNX`̒S̉ʒui0[A0.5^񒆁A1E[j</param>
        /// <param name="fCh"        >eNX`̒S̏cʒui0[A0.5^񒆁A1[j</param>
        /// <param name="iColor"     >FB̂܂܂̐F̏ꍇ-1B</param>
        /// <param name="mdxTexture" >eNX`B</param>
        /// <param name="mdxDrawMode">\@B</param>
        public void SpriteDraw(int iX, int iY, float fCw, float fCh, int iColor, MDXTexture mdxTexture, MDXDrawMode mdxDrawMode)
        {
            switch (mdxDrawMode)
            {
                case MDXDrawMode.Normal:
                    if (SpriteTransformFlag || SpriteDrawMode != mdxDrawMode)
                    {
                        Sprite.Transform = SpriteDrawMatrix_Normal;
                        SpriteTransformFlag = false;
                        SpriteDrawMode = mdxDrawMode;
                    }
                    V3Tmp1.X = mdxTexture.Width * fCw; V3Tmp1.Y = mdxTexture.Height * fCh; V3Tmp1.Z = 0.0f;
                    V3Tmp2.X = iX; V3Tmp2.Y = iY; V3Tmp2.Z = 0.0f;
                    Sprite.Draw(mdxTexture.Texture, V3Tmp1, V3Tmp2, iColor);
                    break;

                case MDXDrawMode.LRInvert:
                    if (SpriteTransformFlag || SpriteDrawMode != mdxDrawMode)
                    {
                        Sprite.Transform = SpriteDrawMatrix_LRInvert;
                        SpriteTransformFlag = false;
                        SpriteDrawMode = mdxDrawMode;
                    }
                    V3Tmp1.X=mdxTexture.Width * fCw;V3Tmp1.Y=mdxTexture.Height * fCh;V3Tmp1.Z=0.0f;
                    V3Tmp2.X = -iX; V3Tmp2.Y = iY; V3Tmp2.Z = 0.0f;
                    Sprite.Draw(mdxTexture.Texture, V3Tmp1, V3Tmp2, iColor);
                    break;

                case MDXDrawMode.TDInvert:
                    if (SpriteTransformFlag || SpriteDrawMode != mdxDrawMode)
                    {
                        Sprite.Transform = SpriteDrawMatrix_TDInvert;
                        SpriteTransformFlag = false;
                        SpriteDrawMode = mdxDrawMode;
                    }
                    V3Tmp1.X = mdxTexture.Width * fCw; V3Tmp1.Y = mdxTexture.Height * fCh; V3Tmp1.Z = 0.0f;
                    V3Tmp2.X=iX;V3Tmp2.Y=-iY;V3Tmp2.Z=0.0f;
                    Sprite.Draw(mdxTexture.Texture, V3Tmp1, V3Tmp2, iColor);
                    break;
            }
        }

        /// <summary>
        /// XvCgŕ`悷B
        /// </summary>
        /// <param name="iX"         >XvCg̍XWifBXvC̕`悳ʒuj</param>
        /// <param name="iY"         >XvCg̍YWifBXvC̕`悳ʒuj</param>
        /// <param name="iColor"     >FB̂܂܂̐F̏ꍇ-1B</param>
        /// <param name="sText"      >`悷镶B</param>
        public void SpriteTextDraw(int iX, int iY, int iColor, string sText)
        {
            if (SpriteTransformFlag || SpriteDrawMode != MDXDrawMode.Normal) //ʂȏ炷
            {
                Sprite.Transform = SpriteDrawMatrix_Normal;
                SpriteTransformFlag = false;
                SpriteDrawMode = MDXDrawMode.Normal;
            }
            this.Font.DrawText(Sprite, sText, iX, iY, iColor);
        }

        /// <summary>
        /// XvCgŕ`悷B
        /// </summary>
        /// <param name="iX"         >XvCg̍XWifBXvC̕`悳ʒuj</param>
        /// <param name="iY"         >XvCg̍YWifBXvC̕`悳ʒuj</param>
        /// <param name="iColor"     >FB̂܂܂̐F̏ꍇ-1B</param>
        /// <param name="sText"      >`悷镶B</param>
        /// <param name="mdxFont"    >`ɗptHgB</param>
        public void SpriteTextDraw(int iX, int iY, int iColor, string sText, MDXFont mdxFont)
        {
            if (SpriteTransformFlag || SpriteDrawMode != MDXDrawMode.Normal) //ʂȏ炷
            {
                Sprite.Transform = SpriteDrawMatrix_Normal;
                SpriteTransformFlag = false;
                SpriteDrawMode = MDXDrawMode.Normal;
            }
            mdxFont.Font.DrawText(Sprite, sText, iX, iY, iColor);
        }

        /// <summary>
        /// XvCgŕ`悷B
        /// </summary>
        /// <param name="iX"          >XvCg̒SXWifBXvC̕`悳ʒuj</param>
        /// <param name="iY"          >XvCg̒SYWifBXvC̕`悳ʒuj</param>
        /// <param name="iTextCenterX">̒SXWB̍[牽pixelڂSB</param>
        /// <param name="iTextCenterY">̒SYWB̏[牽pixelڂSB</param>
        /// <param name="fZoom"       >g嗦(0.5:A1:̂܂܁A2:{)</param>
        /// <param name="fAngle"      >]px(0:̂܂)</param>
        /// <param name="iColor"      >FB̂܂܂̐F̏ꍇ-1B</param>
        /// <param name="mdxDrawMode" >\@B</param>
        /// <param name="sText"       >`悷镶B</param>
        public void SpriteTextDraw(int iX, int iY, int iTextCenterX, int iTextCenterY, float fZoom, float fAngle, int iColor, MDXDrawMode mdxDrawMode, string sText)
        {
            switch (mdxDrawMode)
            {
                case MDXDrawMode.Normal:
                    V2Tmp1.X = iX; V2Tmp1.Y = iY;
                    Sprite.Transform = Matrix.AffineTransformation2D(fZoom, V2Empty, fAngle, V2Tmp1);
                    Font.DrawText(Sprite, sText, -iTextCenterX, -iTextCenterY, iColor);
                    break;

                case MDXDrawMode.LRInvert:
                    V2Tmp1.X = -iX; V2Tmp1.Y = iY;
                    Sprite.Transform = Matrix.AffineTransformation2D(fZoom, V2Empty, -fAngle, V2Tmp1) * SpriteDrawMatrix_LRInvert;
                    Font.DrawText(Sprite, sText, -iTextCenterX, -iTextCenterY, iColor);
                    break;

                case MDXDrawMode.TDInvert:
                    V2Tmp1.X = iX; V2Tmp1.Y = -iY;
                    Sprite.Transform = Matrix.AffineTransformation2D(fZoom, V2Empty, -fAngle, V2Tmp1) * SpriteDrawMatrix_TDInvert;
                    Font.DrawText(Sprite, sText, -iTextCenterX, -iTextCenterY, iColor);
                    break;
            }
            SpriteTransformFlag = true;
        }

        /// <summary>
        /// XvCgŕ`悷B
        /// </summary>
        /// <param name="iX"          >XvCg̒SXWifBXvC̕`悳ʒuj</param>
        /// <param name="iY"          >XvCg̒SYWifBXvC̕`悳ʒuj</param>
        /// <param name="iTextCenterX">̒SXWB̍[牽pixelڂSB</param>
        /// <param name="iTextCenterY">̒SYWB̏[牽pixelڂSB</param>
        /// <param name="fZoom"       >g嗦(0.5:A1:̂܂܁A2:{)</param>
        /// <param name="fAngle"      >]px(0:̂܂)</param>
        /// <param name="iColor"      >FB̂܂܂̐F̏ꍇ-1B</param>
        /// <param name="mdxDrawMode" >\@B</param>
        /// <param name="sText"       >`悷镶B</param>
        /// <param name="mdxFont"     >`ɗptHgB</param>
        public void SpriteTextDraw(int iX, int iY, int iTextCenterX, int iTextCenterY, float fZoom, float fAngle, int iColor, MDXDrawMode mdxDrawMode, string sText, MDXFont mdxFont)
        {
            switch (mdxDrawMode)
            {
                case MDXDrawMode.Normal:
                    V2Tmp1.X = iX; V2Tmp1.Y = iY;
                    Sprite.Transform = Matrix.AffineTransformation2D(fZoom, V2Empty, fAngle, V2Tmp1);
                    mdxFont.Font.DrawText(Sprite, sText, -iTextCenterX, -iTextCenterY, iColor);
                    break;

                case MDXDrawMode.LRInvert:
                    V2Tmp1.X = -iX; V2Tmp1.Y = iY;
                    Sprite.Transform = Matrix.AffineTransformation2D(fZoom, V2Empty, -fAngle, V2Tmp1) * SpriteDrawMatrix_LRInvert;
                    mdxFont.Font.DrawText(Sprite, sText, -iTextCenterX, -iTextCenterY, iColor);
                    break;

                case MDXDrawMode.TDInvert:
                    V2Tmp1.X = iX; V2Tmp1.Y = -iY;
                    Sprite.Transform = Matrix.AffineTransformation2D(fZoom, V2Empty, -fAngle, V2Tmp1) * SpriteDrawMatrix_TDInvert;
                    mdxFont.Font.DrawText(Sprite, sText, -iTextCenterX, -iTextCenterY, iColor);
                    break;
            }
            SpriteTransformFlag = true;
        }

        #endregion `揈


        #region    Dispose֘A
        
        /// <summary>
        /// \[X̊JB
        /// </summary>
        public void Dispose()
        {
            if (this.Device != null)
            {
                this.Device.Dispose();
                this.Device = null;
            }

            if (this.Font != null)
            {
                this.Font.Dispose();
                this.Font = null;
            }

            if (this.RectVertBuffer != null)
            {
                this.RectVertBuffer.Dispose();
                this.RectVertBuffer = null;
            }

            if (this.Sprite != null)
            {
                this.Sprite.Dispose();
                this.Sprite = null;
            }
        }

        void IDisposable.Dispose()
        {
            this.Dispose();
        }

        #endregion Dispose֘A


        #region    ̑

        /// <summary>
        /// tHg擾B
        /// </summary>
        /// <param name="sFontName">tHgiFlr SVbNj</param>
        /// <param name="iHeight"  >tHg̃TCYB</param>
        /// <returns>tHgIuWFNgB</returns>
        public MDXFont GetFont(string sFontName, int iHeight)
        {
            return new MDXFont(this, sFontName, iHeight);
        }

        /// <summary>
        /// eNX`擾B
        /// </summary>
        /// <param name="sFileName">eNX`t@Cibmp,gif,jpg...j</param>
        /// <returns>eNX`\IuWFNgB</returns>
        public MDXTexture GetTexture(string sFileName)
        {
            return new MDXTexture(this, sFileName);
        }

        /// <summary>
        /// eNX`擾B
        /// </summary>
        /// <param name="sFileName">eNX`t@Cibmp,gif,jpg...j</param>
        /// <param name="fZoom"    >g嗦(0.5:A1:̂܂܁A2:{)</param>
        /// <returns>eNX`\IuWFNgB</returns>
        public MDXTexture GetTexture(string sFileName, float fZoom)
        {
            return new MDXTexture(this, sFileName, fZoom);
        }

        /// <summary>
        /// eNX`擾B
        /// </summary>
        /// <param name="sFileName">eNX`t@Cibmp,gif,jpg...j</param>
        /// <param name="iWidth"   >B</param>
        /// <param name="iHeight"  >B</param>
        /// <returns>eNX`\IuWFNgB</returns>
        public MDXTexture GetTexture(string sFileName, int iWidth, int iHeight)
        {
            return new MDXTexture(this, sFileName, iWidth, iHeight);
        }

        #endregion ̑

        #endregion \bh
    }
}
