using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

namespace MDXLibrary.DXGraphics
{
    /// <summary>
    /// Direct3D.TextureNXȒPɗpNXB
    /// MDXGraphicsNXŗpB
    /// </summary>
    public class MDXTexture:IDisposable
    {
        #region    IuWFNg
        public Texture            Texture;
        public Device             Device;
        public int                Width;
        public int                Height;

        #endregion IuWFNg


        #region    \bh

        #region    RXgN^

        /// <summary>
        /// RXgN^BeNX`摜ǂݍށB
        /// </summary>
        /// <param name="mdxGraphics">e</param>
        /// <param name="sFileName"  >eNX`t@Cibmp,gif,jpg...j</param>
        public MDXTexture(MDXGraphics mdxGraphics, string sFileName)
        {
            this.Device = mdxGraphics.Device;
            Load(sFileName);
        }

        /// <summary>
        /// RXgN^BeNX`摜ǂݍށB
        /// </summary>
        /// <param name="mdxGraphics">e</param>
        /// <param name="sFileName"  >eNX`t@Cibmp,gif,jpg...j</param>
        /// <param name="iWidth"     ></param>
        /// <param name="iHeight"    ></param>
        public MDXTexture(MDXGraphics mdxGraphics, string sFileName, int iWidth, int iHeight)
        {
            this.Device = mdxGraphics.Device;
            Load(sFileName, iWidth, iHeight);
        }

        /// <summary>
        /// RXgN^BeNX`摜ǂݍށB
        /// </summary>
        /// <param name="mdxGraphics">e</param>
        /// <param name="sFileName"  >eNX`t@Cibmp,gif,jpg...j</param>
        /// <param name="fZoom"      >g嗦B1:̂܂܁A0.5:A2:{</param>
        public MDXTexture(MDXGraphics mdxGraphics, string sFileName, float fZoom)
        {
            this.Device = mdxGraphics.Device;
            Load(sFileName, fZoom);
        }

        #endregion RXgN^


        #region    ǂݍ݊֘A

        /// <summary>
        /// eNX`摜ǂݍށB
        /// </summary>
        /// <param name="sFileName">eNX`t@Cibmp,gif,jpg...j</param>
        public void Load(string sFileName)
        {
            Bitmap bSrcBmp = new Bitmap(this.GetMatchFileName(sFileName));
            this.Texture = Texture.FromBitmap(this.Device, bSrcBmp, Usage.None, Pool.Managed);
            bSrcBmp.Dispose();
            this.Width  = this.Texture.GetLevelDescription(0).Width;
            this.Height = this.Texture.GetLevelDescription(0).Height;
        }

        /// <summary>
        /// eNX`摜ǂݍށB
        /// </summary>
        /// <param name="sFileName">eNX`t@Cibmp,gif,jpg...j</param>
        /// <param name="iWidth"   ></param>
        /// <param name="iHeight"  ></param>
        public void Load(string sFileName, int iWidth, int iHeight)
        {
            Bitmap bSrcBmp = new Bitmap(this.GetMatchFileName(sFileName));
            Bitmap bTexBmp = new Bitmap(iWidth, iHeight);
            Graphics g = Graphics.FromImage(bTexBmp);
            g.DrawImage(bSrcBmp, 0, 0, iWidth, iHeight);
            this.Texture = Texture.FromBitmap(this.Device, bTexBmp, Usage.None, Pool.Managed);
            bSrcBmp.Dispose();
            bTexBmp.Dispose();
            g.Dispose();
            this.Width  = this.Texture.GetLevelDescription(0).Width;
            this.Height = this.Texture.GetLevelDescription(0).Height;
        }

        /// <summary>
        /// eNX`摜ǂݍށB
        /// </summary>
        /// <param name="sFileName">eNX`t@Cibmp,gif,jpg...j</param>
        /// <param name="fZoom"    >g嗦B1:̂܂܁A0.5:A2:{</param>
        public void Load(string sFileName, float fZoom)
        {
            Bitmap bSrcBmp = new Bitmap(this.GetMatchFileName(sFileName));
            int iW = (int)((float)bSrcBmp.Width * fZoom);
            int iH = (int)((float)bSrcBmp.Height * fZoom);
            Bitmap bTexBmp = new Bitmap(iW, iH);
            Graphics g = Graphics.FromImage(bTexBmp);
            g.DrawImage(bSrcBmp, 0, 0, iW, iH);
            this.Texture = Texture.FromBitmap(this.Device, bTexBmp, Usage.None, Pool.Managed);
            bSrcBmp.Dispose();
            bTexBmp.Dispose();
            g.Dispose();
            this.Width  = this.Texture.GetLevelDescription(0).Width;
            this.Height = this.Texture.GetLevelDescription(0).Height;
        }

        #endregion ǂݍ݊֘A


        #region    Dispose֘A

        /// <summary>
        /// \[X̊JB
        /// </summary>
        public void Dispose()
        {
            if (this.Texture != null)
            {
                this.Texture.Dispose();
                this.Texture = null;
            }
        }

        void IDisposable.Dispose()
        {
            this.Dispose();
        }

        #endregion Dispose֘A


        #region    Tu[`

        private string GetMatchFileName(string sFileName) {
            string sTrueFileName = "";
            if (System.IO.File.Exists(sFileName)) {
                sTrueFileName = sFileName;
            } else {
                foreach (string s in System.IO.Directory.GetFiles(System.IO.Path.GetDirectoryName(sFileName))) {
                    if (System.Text.RegularExpressions.Regex.Match(System.IO.Path.GetFileName(s), "^" + System.IO.Path.GetFileName(sFileName), System.Text.RegularExpressions.RegexOptions.IgnoreCase).Value != "") {
                        sTrueFileName = s;
                        break;
                    }
                }
            }
            return sTrueFileName;
        }

        #endregion Tu[`

        #endregion \bh
    }
}
