using System;
using System.Collections.Generic;
using System.Text;

using Microsoft.DirectX;
using Microsoft.DirectX.DirectInput;

namespace MDXLibrary.DXInput
{
    /// <summary>
    /// DirectInputȒPɗpNXB
    /// </summary>
    public class MDXInput:IDisposable
    {
        #region    NX

        /// <summary>
        /// zfoCX̐ݒi[NX
        /// @ez̑ꎟFzfoCXԍ
        /// @ez̑񎟌FzfoCX̃{^ԍ
        /// </summary>
        public class VirtualDefineSetting
        {
            public string[] ButtonDescription;
            public int[][]  JoystickDevNum;
            public int[][]  JoystickBtnNum;
            public Key[][]  Keyboard;
        }

        #endregion NX


        #region    IuWFNg

        public  VirtualDefineSetting VirtualDefine = new VirtualDefineSetting();
        public  Device               DevMouse;
        public  Device               DevKeyboard;
        public  Device[]             DevJoysticks;
        public  EffectObject[]       EffJoysticks;

        #endregion IuWFNg


        #region    \bh

        #region    RXgN^

        /// <summary>
        /// RXgN^B
        /// </summary>
        /// <param name="parent">e</param>
        public MDXInput(System.Windows.Forms.Control parent, CooperativeLevelFlags clfLevel)
        {
            //DirectInput(}EXj
            DevMouse = new Device(SystemGuid.Mouse);
            DevMouse.Properties.AxisModeAbsolute = false;
            DevMouse.SetCooperativeLevel(parent, clfLevel);
            DevMouse.Acquire();

            //DirectInput(L[{[hj
            DevKeyboard = new Device(SystemGuid.Keyboard);
            DevKeyboard.SetCooperativeLevel(parent, clfLevel);
            DevKeyboard.Acquire();

            //DirectInput(WCXeBbNj
            DevJoysticks = null;
            EffJoysticks = null;
            DeviceList dl = Manager.GetDevices(DeviceClass.GameControl, EnumDevicesFlags.AttachedOnly);
            DevJoysticks = new Device[dl.Count];
            EffJoysticks = new EffectObject[dl.Count];
            int iNum = 0;
            foreach (DeviceInstance di in dl)
            {
                DevJoysticks[iNum] = new Device(di.InstanceGuid);
                DevJoysticks[iNum].SetCooperativeLevel(parent, clfLevel);
                DevJoysticks[iNum].Properties.AxisModeAbsolute = true;
                DevJoysticks[iNum].Acquire();

                int iAxesLength = 0;
                foreach (DeviceObjectInstance doi in DevJoysticks[iNum].Objects)
                {
                    //͈̔͐ݒ
                    if ((doi.ObjectId & (int)DeviceObjectTypeFlags.Axis) != 0)
                    {
                        DevJoysticks[iNum].Properties.SetRange(ParameterHow.ById, doi.ObjectId, new InputRange(-10000, 10000));
                    }

                    if ((doi.Flags & (int)ObjectInstanceFlags.Actuator) != 0)
                    {
                        iAxesLength++;
                    }
                }

                int iCount = 0;
                int[] iAxes = new int[2];
                foreach (DeviceObjectInstance doi in DevJoysticks[iNum].Objects)
                {
                    if ((doi.Flags & (int)ObjectInstanceFlags.Actuator) != 0)
                    {
                        iAxes[iCount++] = doi.Offset;
                        if (iCount == 2) break;
                    }
                }

                foreach (EffectInformation ei in DevJoysticks[iNum].GetEffects(EffectType.ConstantForce))
                {
                    if (DInputHelper.GetTypeCode(ei.EffectType) == (int)EffectType.ConstantForce)
                    {
                        Effect e = new Effect();
                        e.SetDirection(new int[iAxes.Length]);
                        e.SetAxes(new int[iAxes.Length]);
                        e.ConditionStruct = new Condition[iAxes.Length];

                        e.EffectType            = EffectType.ConstantForce;
                        e.Duration              = (int)DI.Infinite;
                        e.Gain                  = 10000;
                        e.SamplePeriod          = 0;
                        e.Constant.Magnitude    = 10000;
                        e.TriggerButton         = (int)Button.NoTrigger;
                        e.TriggerRepeatInterval = (int)DI.Infinite;
                        e.Flags                 = EffectFlags.Cartesian | EffectFlags.ObjectOffsets;
                        e.SetAxes(iAxes);

                        EffJoysticks[iNum] = new EffectObject(ei.EffectGuid, e, DevJoysticks[iNum]);
                        break;
                    }
                }
                iNum++;
            }
        }

        public MDXInput(System.Windows.Forms.Control parent)
            : this(parent, CooperativeLevelFlags.Foreground | CooperativeLevelFlags.Exclusive)
        {
        }

        #endregion RXgN^


        #region    }EX֘A

        /// <summary>
        /// ݂̃}EX̏Ԃ擾B
        /// </summary>
        /// <returns>݂̃}EX̏Ԃ\IuWFNgB</returns>
        public MouseState MouseGetState()
        {
            MouseState ms;
            try
            {
                ms = this.DevMouse.CurrentMouseState;
            }
            catch //(InputLostException)
            {
                while (true)
                {
                    try
                    {
                        this.DevMouse.Acquire();
                        ms = this.DevMouse.CurrentMouseState;
                        break;
                    }
                    catch(OtherApplicationHasPriorityException)
                    {
                        System.Threading.Thread.Sleep(100);
                        System.Windows.Forms.Application.DoEvents();
                    }
                }
            }
            //catch (EffectPlayingException)
            //{
            //    ms = new MouseState();
            //}
            return ms;
        }

        #endregion }EX֘A


        #region    L[{[h֘A

        /// <summary>
        /// ݂̃L[{[h̏Ԃ擾B
        /// </summary>
        /// <returns>݂̃L[{[h̏Ԃ\IuWFNgB</returns>
        public KeyboardState KeyboardGetState()
        {
            KeyboardState ks;
            try
            {
                ks = this.DevKeyboard.GetCurrentKeyboardState();
            }
            catch //(InputLostException)
            {
                while (true)
                {
                    try
                    {
                        this.DevKeyboard.Acquire();
                        ks = this.DevKeyboard.GetCurrentKeyboardState();
                        break;
                    }
                    catch (OtherApplicationHasPriorityException)
                    {
                        System.Threading.Thread.Sleep(100);
                        System.Windows.Forms.Application.DoEvents();
                    }
                }
            }
            return ks;
        }

        /// <summary>
        /// ǑĂяo猻݂܂łɉꂽL[擾BԂBB
        /// </summary>
        /// <returns>ꂽL[\zB</returns>
        public Key[] KeyboardGetPressedKeys() 
        {
            Key[] k;
            try
            {
                k = this.DevKeyboard.GetPressedKeys();
            }
            catch //(InputLostException)
            {
                while (true)
                {
                    try
                    {
                        this.DevKeyboard.Acquire();
                        k = this.DevKeyboard.GetPressedKeys();
                        break;
                    }
                    catch (OtherApplicationHasPriorityException)
                    {
                        System.Threading.Thread.Sleep(100);
                        System.Windows.Forms.Application.DoEvents();
                    }
                }
            }
            return k;
        }

        #endregion L[{[h֘A


        #region    WCXeBbN֘A

        JoystickState NullJoyStickState = new JoystickState(); //WCXeBbN݂ȂꍇɂƂ肠ԂpEEE

        /// <summary>
        /// ݂̃WCXeBbN̏Ԃ擾B
        /// </summary>
        /// <param name="JoystickNo">WCXeBbNԍB</param>
        /// <returns>݂̃WCXeBbN̏Ԃ\IuWFNgB</returns>
        public JoystickState JoystickGetState(int JoystickNo) 
        {
            JoystickState js;
            if (JoystickNo < DevJoysticks.Length && DevJoysticks[JoystickNo] != null)
            {
                try
                {
                    js = this.DevJoysticks[JoystickNo].CurrentJoystickState;
                }
                catch //(InputLostException)
                {
                    while (true)
                    {
                        try
                        {
                            this.DevJoysticks[JoystickNo].Acquire();
                            js = this.DevJoysticks[JoystickNo].CurrentJoystickState;
                            break;
                        }
                        catch (OtherApplicationHasPriorityException)
                        {
                            System.Threading.Thread.Sleep(100);
                            System.Windows.Forms.Application.DoEvents();
                        }
                    }
                }
            }
            else
            {
                js = NullJoyStickState;
            }
            return js;
        }

        /// <summary>
        /// ڑĂWCXeBbŇ擾B
        /// </summary>
        /// <returns>ڑĂWCXeBbŇB</returns>
        public int JoystickGetCount() 
        {
            return this.DevJoysticks.Length;
        }

        /// <summary>
        /// WCXeBbN̐UJnB
        /// </summary>
        /// <param name="JoystickNo">WCXeBbNԍB</param>
        public void JoystickEffectStart(int JoystickNo)
        {
            if (JoystickNo < DevJoysticks.Length && EffJoysticks[JoystickNo] != null)
            {
                if (!this.JoystickEffectGetPlaying(JoystickNo))
                {
                    this.EffJoysticks[JoystickNo].Start(1, EffectStartFlags.NoDownload);
                }
            }
        }

        /// <summary>
        /// WCXeBbN̐U~B
        /// </summary>
        /// <param name="JoystickNo">WCXeBbNԍB</param>
        public void JoystickEffectStop(int JoystickNo)
        {
            if (JoystickNo < DevJoysticks.Length && EffJoysticks[JoystickNo] != null)
            {
                if (this.JoystickEffectGetPlaying(JoystickNo))
                {
                    this.EffJoysticks[JoystickNo].Stop();
                }
            }
        }

        /// <summary>
        /// WCXeBbN̐Űݒ肷B
        /// </summary>
        /// <param name="JoystickNo">WCXeBbNԍB</param>
        /// <param name="Gain"      >ŰB</param>
        public void JoystickEffectSetGain(int JoystickNo, int Gain) 
        {
            if (JoystickNo < DevJoysticks.Length && EffJoysticks[JoystickNo] != null)
            {
                Effect e = new Effect();
                e.Flags = EffectFlags.Cartesian | EffectFlags.ObjectOffsets;
                this.EffJoysticks[JoystickNo].GetParameters(ref e, EffectParameterFlags.AllParams);
                if (e.Gain != Gain)
                {
                    e.Gain = Gain;
                    this.EffJoysticks[JoystickNo].SetParameters(e, EffectParameterFlags.Gain);
                    if (this.EffJoysticks[JoystickNo].EffectStatus.Playing)
                    {
                        this.EffJoysticks[JoystickNo].Stop();
                        this.EffJoysticks[JoystickNo].Start(1, EffectStartFlags.NoDownload);
                    }
                }
            }
        }

        /// <summary>
        /// WCXeBbNUǂ擾B
        /// </summary>
        /// <param name="JoystickNo">WCXeBbNԍB</param>
        /// <returns>UȂtrueB</returns>
        public bool JoystickEffectGetPlaying(int JoystickNo) 
        {
            bool bRet;
            if (JoystickNo < DevJoysticks.Length && EffJoysticks[JoystickNo] != null)
            {
                try
                {
                    bRet = this.EffJoysticks[JoystickNo].EffectStatus.Playing;
                }
                catch //(InputLostException)
                {
                    while (true)
                    {
                        try
                        {
                            this.DevJoysticks[JoystickNo].Acquire();
                            this.EffJoysticks[JoystickNo].Download();
                            bRet = this.EffJoysticks[JoystickNo].EffectStatus.Playing;
                            break;
                        }
                        catch (OtherApplicationHasPriorityException)
                        {
                            System.Threading.Thread.Sleep(100);
                            System.Windows.Forms.Application.DoEvents();
                        }
                    }
                }
            }
            else
            {
                bRet = false;
            }
            return bRet;
        }

        /// <summary>
        /// WCXeBbNUɑΉĂ邩ǂ擾B
        /// </summary>
        /// <param name="JoystickNo">WCXeBbNԍB</param>
        /// <returns>UɑΉĂȂtrueB</returns>
        public bool JoystickEffectGetEnable(int JoystickNo) 
        {
            if (JoystickNo < DevJoysticks.Length && this.EffJoysticks[JoystickNo] != null)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        #endregion WCXeBbN֘A


        #region    z{^֘A

        private byte[][] VirtualButtons;

        /// <summary>
        /// zfoCX`B
        /// </summary>
        /// <param name="iDeviceNum">zfoCX̌BiFlpQ[ȂRg[QKvȂ̂Łu2vjB</param>
        /// <param name="iButtonNum">ezfoCX̃{^B</param>
        public void VirtualDeviceDefine(int iDeviceNum, int iButtonNum, string[] sDescription)
        {
            VirtualButtons = new byte[iDeviceNum][];
            for (int i = 0; i < iDeviceNum; i++) VirtualButtons[i] = new byte[iButtonNum];

            VirtualDefine.JoystickDevNum = new int[iDeviceNum][];
            for (int i = 0; i < iDeviceNum; i++) VirtualDefine.JoystickDevNum[i] = new int[iButtonNum];

            VirtualDefine.JoystickBtnNum = new int[iDeviceNum][];
            for (int i = 0; i < iDeviceNum; i++) VirtualDefine.JoystickBtnNum[i] = new int[iButtonNum];

            VirtualDefine.Keyboard = new Key[iDeviceNum][];
            for (int i = 0; i < iDeviceNum; i++)
            {
                VirtualDefine.Keyboard[i] = new Key[iButtonNum];
                for (int j = 0; j < iButtonNum; j++)
                {
                    VirtualDefine.Keyboard[i][j] = Key.Stop;
                }
            }

            VirtualDefine.ButtonDescription = new string[iButtonNum];
            for (int i = 0; i < iButtonNum; i++)
            {
                VirtualDefine.ButtonDescription[i] = sDescription[i];
            }
        }

        /// <summary>
        /// zfoCX̃{^ɕfoCX̃{^тB
        /// </summary>
        /// <param name="iDeviceNum">zfoCXԍB</param>
        /// <param name="iButtonNum">zfoCX̃{^ԍB</param>
        /// <param name="kKey"      >L[{[h̃{^\lB</param>
        public void VirtualButtonDefine(int iDeviceNum, int iButtonNum, Key kKey)
        {
            VirtualDefine.Keyboard[iDeviceNum][iButtonNum] = kKey;
        }

        /// <summary>
        /// zfoCX̃{^ɕfoCX̃{^тB
        /// </summary>
        /// <param name="iDeviceNum"        >zfoCXԍB</param>
        /// <param name="iButtonNum"        >zfoCX̃{^ԍB</param>
        /// <param name="iJoystickNum"      >WCXeBbNԍB</param>
        /// <param name="iJoystickButtonNum">WCXeBbÑ{^ԍB</param>
        public void VirtualButtonDefine(int iDeviceNum, int iButtonNum, int iJoystickNum, int iJoystickButtonNum)
        {
            VirtualDefine.JoystickDevNum[iDeviceNum][iButtonNum] = iJoystickNum;
            VirtualDefine.JoystickBtnNum[iDeviceNum][iButtonNum] = iJoystickButtonNum;
        }

        /// <summary>
        /// zfoCX̂ǂ̃{^Ă邩ԂB
        /// ۂɂ͉zfoCXɌѕtꂽfoCX̃{^̏Ԃ擾B
        /// </summary>
        /// <param name="iDeviceNum">zfoCXԍB</param>
        /// <returns>zfoCX̃{^̏Ԃ\zBz̃CfbNX̓{^ԍɑΉB</returns>
        public byte[] VirtualGetButtons(int iDeviceNum)
        {
            this.VirtualUpdate();
            return VirtualButtons[iDeviceNum];
        }

        /// <summary>
        /// zfoCX̂ǂ̃{^Ă邩Ԃ擾B
        /// VirtualGetButtonsŕԂz̎ԂXVB
        /// </summary>
        public void VirtualUpdate()
        {
            KeyboardState ksKeyboard;
            try
            {
                ksKeyboard = this.DevKeyboard.GetCurrentKeyboardState();
            }
            catch //(InputLostException)
            {
                while (true)
                {
                    try
                    {
                        this.DevKeyboard.Acquire();
                        ksKeyboard = this.DevKeyboard.GetCurrentKeyboardState();
                        break;
                    }
                    catch (OtherApplicationHasPriorityException)
                    {
                        System.Threading.Thread.Sleep(100);
                        System.Windows.Forms.Application.DoEvents();
                    }
                }
            }
            for (int iDevNum = 0; iDevNum < VirtualDefine.Keyboard.Length; iDevNum++)
            {
                for (int iBtnNum = 0; iBtnNum < VirtualDefine.Keyboard[iDevNum].Length; iBtnNum++)
                {

                    if (ksKeyboard[VirtualDefine.Keyboard[iDevNum][iBtnNum]])
                    {
                        VirtualButtons[iDevNum][iBtnNum] = 128;
                    }
                    else
                    {
                        VirtualButtons[iDevNum][iBtnNum] = 0;
                    }
                }
            }

            for (int iJoyStickNum = 0; iJoyStickNum < DevJoysticks.Length; iJoyStickNum++)
            {
                byte[] bJoystickBtns;
                try
                {
                    bJoystickBtns = this.DevJoysticks[iJoyStickNum].CurrentJoystickState.GetButtons();
                }
                catch //(InputLostException)
                {
                    while (true)
                    {
                        try
                        {
                            this.DevJoysticks[iJoyStickNum].Acquire();
                            bJoystickBtns = this.DevJoysticks[iJoyStickNum].CurrentJoystickState.GetButtons();
                            break;
                        }
                        catch (OtherApplicationHasPriorityException)
                        {
                            System.Threading.Thread.Sleep(100);
                            System.Windows.Forms.Application.DoEvents();
                        }
                    }
                }

                for (int iDevNum = 0; iDevNum < VirtualDefine.Keyboard.Length; iDevNum++)
                {
                    for (int iBtnNum = 0; iBtnNum < VirtualDefine.Keyboard[iDevNum].Length; iBtnNum++)
                    {
                        if (VirtualDefine.JoystickDevNum[iDevNum][iBtnNum] == iJoyStickNum)
                        {
                            if (bJoystickBtns[VirtualDefine.JoystickBtnNum[iDevNum][iBtnNum]] != 0)
                            {
                                VirtualButtons[iDevNum][iBtnNum] = bJoystickBtns[VirtualDefine.JoystickBtnNum[iDevNum][iBtnNum]];
                            }
                        }
                    }
                }
            }
        }

        /// <summary>
        /// zfoCX̐ݒifoCXƂ̊֘Atjt@CɕۑB
        /// </summary>
        /// <param name="sPath">t@CB</param>
        public void VirtualDefineSettingSave(string sPath)
        {
            System.IO.FileStream fs = new System.IO.FileStream(sPath, System.IO.FileMode.Create);
            new System.Xml.Serialization.XmlSerializer(VirtualDefine.GetType()).Serialize(fs, VirtualDefine);
            fs.Close();
        }

        /// <summary>
        /// zfoCX̐ݒifoCXƂ̊֘Atjt@CǂݍށB
        /// </summary>
        /// <param name="sPath">t@CB</param>
        public void VirtualDefineSettingLoad(string sPath)
        {
            System.IO.FileStream fs = new System.IO.FileStream(sPath, System.IO.FileMode.Open);
            VirtualDefine = (VirtualDefineSetting)new System.Xml.Serialization.XmlSerializer(VirtualDefine.GetType()).Deserialize(fs);
            fs.Close();

            //ǂݍ񂾓eɂ킹ĉzL[zTCYύX
            int iDeviceNum = VirtualDefine.Keyboard.Length;
            int iButtonNum = VirtualDefine.Keyboard[0].Length;
            VirtualButtons = new byte[iDeviceNum][];
            for (int i = 0; i < iDeviceNum; i++) VirtualButtons[i] = new byte[iButtonNum];
        }

        #endregion z{^֘A


        #region    Dispose֘A

        /// <summary>
        /// \[X̊JB
        /// </summary>
        public void Dispose()
        {
            if (this.DevMouse != null)
            {
                this.DevMouse.Dispose();
                this.DevMouse = null;
            }

            if (this.DevKeyboard != null)
            {
                this.DevKeyboard.Dispose();
                this.DevKeyboard = null;
            }

            if (this.DevJoysticks != null)
            {
                foreach (Device d in this.DevJoysticks)
                {
                    if (d != null)
                    {
                        d.Dispose();
                    }
                }
                this.DevJoysticks = null;
            }

            if (this.EffJoysticks != null)
            {
                foreach (EffectObject eo in this.EffJoysticks)
                {
                    if (eo != null)
                    {
                        eo.Dispose();
                    }
                }
                this.EffJoysticks = null;
            }
        }

        void IDisposable.Dispose()
        {
            this.Dispose();
        }

        #endregion Dispose֘A

        #endregion \bh
    }
}
