using System;
using System.Collections.Generic;
using System.Text;

using Microsoft.DirectX;
using Microsoft.DirectX.DirectSound;
using Microsoft.DirectX.AudioVideoPlayback;

namespace MDXLibrary.DXSound
{
    /// <summary>
    /// ʉ≹yĐȒPɎs邽߂̃NXB
    /// ʉɂDirectSoundi3Dɂ͑ΉĂ܂jA
    /// yĐɂAudioVideoPlaybackp܂B
    /// </summary>
    public class MDXSound:IDisposable
    {
        #region    NX
        
        /// <summary>
        /// yt@Čʐݒۑ邽߂̃NX
        /// </summary>
        public class MusicSetting {
            public int Volume;

            public MusicSetting() {
                this.SetDefault();
            }

            public void SetDefault() {
                this.Volume = 0;
            }

            public void Save(string sFileName) {
                System.IO.FileStream fs = new System.IO.FileStream(sFileName, System.IO.FileMode.Create);
                new System.Xml.Serialization.XmlSerializer(this.GetType()).Serialize(fs, this);
                fs.Close();
            }

            public void Load(string sFileName) {
                System.IO.FileStream fs = new System.IO.FileStream(sFileName, System.IO.FileMode.Open);
                MusicSetting sTmp = (MusicSetting)new System.Xml.Serialization.XmlSerializer(this.GetType()).Deserialize(fs);
                fs.Close();

                this.Volume = sTmp.Volume;
            }
        }

        #endregion NX


        #region    IuWFNg

        public System.Windows.Forms.Control Control;  //eRg[
        public Device                       Device;
        public Audio                        Music;
        public MusicSetting                 MusicSettings;
        public bool                         AudioLoop;
        
        #endregion IuWFNg


        #region    \bh

        #region    RXgN^

        /// <summary>
        /// RXgN^B
        /// </summary>
        /// <param name="cControl">e</param>
        public MDXSound(System.Windows.Forms.Control cControl)
        {
            this.Control       = cControl;
            this.MusicSettings = new MusicSetting();
            this.Device        = new Device();
            this.Device.SetCooperativeLevel(this.Control, CooperativeLevel.Priority);
        }

        #endregion RXgN^


        #region    GtFNg֘A

        /// <summary>
        /// ʉĐ邽߂̃IuWFNgԂB
        /// </summary>
        /// <param name="sWavFileName">ʉi[ꂽt@CBWAV̂݁B</param>
        /// <param name="iMultiMax"   >dĐ̍ő吔B</param>
        /// <param name="mdxPlayMode" >Đ̕@B</param>
        /// <returns>ʉĐ邽߂̃IuWFNgB</returns>
        public MDXSoundEffect GetSoundEffect(string sWavFileName, int iMultiMax, MDXSoundEffectPlayMode mdxPlayMode)
        {
            return new MDXSoundEffect(this, sWavFileName, iMultiMax, mdxPlayMode);
        }

        #endregion GtFNg֘A


        #region    ~[WbN֘A

        /// <summary>
        /// yĐJnB
        /// </summary>
        /// <param name="sFileName">yi[ꂽt@CBwavmp3ȂǁBK\ΉB</param>
        /// <param name="bLoop"    >y[vĐ邩ǂBtrueȂ烋[vB</param>
        public void MusicStart(string sFileName, bool bLoop)
        {
            //t@C𐳋K\Ή
            string sTrueFileName = "";
            if (System.IO.File.Exists(sFileName)) {
                sTrueFileName = sFileName;
            } else {
                foreach (string s in System.IO.Directory.GetFiles(System.IO.Path.GetDirectoryName(sFileName))) {
                    if (System.Text.RegularExpressions.Regex.Match(System.IO.Path.GetFileName(s), "^" + System.IO.Path.GetFileName(sFileName), System.Text.RegularExpressions.RegexOptions.IgnoreCase).Value != "") {
                        if (s.IndexOf(".MusicSetting") < 0) {
                            sTrueFileName = s;
                            break;
                        }
                    }
                }
            }

            if (sTrueFileName == "") {
                this.MusicStop();
            } else {
                this.AudioLoop = bLoop;
                if (this.Music == null) {
                    this.Music = new Audio(sTrueFileName, true);
                    this.Music.Ending += new EventHandler(MusicEnding);
                } else {
                    this.Music.Open(sTrueFileName, true);
                }
                //ݒt@CΓǂݍ
                if (System.IO.File.Exists(sTrueFileName + ".MusicSetting")) {
                    this.MusicSettings.Load(sTrueFileName + ".MusicSetting");
                    this.Music.Volume = this.MusicSettings.Volume;
                } else {
                    this.MusicSettings.SetDefault();
                    this.MusicSettings.Save(sTrueFileName + ".MusicSetting");
                    this.Music.Volume = 0;
                }
            }
        }

        /// <summary>
        /// yĐ~B
        /// </summary>
        public void MusicStop()
        {
            if (this.Music != null)
            {
                this.AudioLoop = false;
                this.Music.Stop();
            }
        }

        public void MusicSetVolume(int iVolume)
        {
            if (this.Music != null)
            {
                this.Music.Volume = iVolume + this.MusicSettings.Volume;
            }
        }

        //~[WbNĐICxg
        private void MusicEnding(object sender, EventArgs e)
        {
            if (this.AudioLoop)
            {
                this.Music.SeekCurrentPosition(0, SeekPositionFlags.AbsolutePositioning);
                this.Music.Play();
            }
        }

        #endregion ~[WbN֘A


        #region    Dispose֘A

        /// <summary>
        /// \[X̊JB
        /// </summary>
        public void Dispose()
        {
            if (this.Device != null)
            {
                this.Device.Dispose();
                this.Device = null;
            }

            if (this.Music != null)
            {
                this.Music.Dispose();
                this.Music = null;
            }
        }

        void IDisposable.Dispose()
        {
            this.Dispose();
        }

        #endregion Dispose֘A

        #endregion \bh
    }
}
