using System;
using System.Collections.Generic;
using System.Text;

using Microsoft.DirectX.DirectInput;

using MDXLibrary.DXGraphics;
using MDXLibrary.DXInput;

namespace Shibuya.Players
{
    /// <summary>
    /// @
    /// </summary>
    public class Player
    {
        const int CLASHWAIT  = 30;
        const int CLASHCOLOR = unchecked((int)0x80ff0000);
        const int HPMAX      = 100;

        #region IuWFNgiJj

        public float      X;
        public float      Y;
        public float      Scale;
        public float      Radius;
        public int        HP;
        public int        Color;
        public int        TotalFrame;
        public bool       Clashed;

        #endregion


        #region IuWFNgiJj

        private MDXTexture Texture;
        private int        ClashWait;

        #endregion


        #region ֐iEJȂǁj
        
        public Player()
        {
            this.Texture   = Pub.Graphics.GetTexture(@"Image\Player.*");
            this.Reset();
        }

        public void Reset()
        {
            this.X          = Pub.WindowWidth / 2;
            this.Y          = Pub.WindowHeight / 2;
            this.Scale      = 1.0f;
            this.Radius     = this.Texture.Width;
            this.Clashed    = false;
            this.ClashWait  = CLASHWAIT;
            this.Color      = -1;
            this.TotalFrame = 0;
            this.HP         = HPMAX;
        }

        public void Dispose()
        {
            if (this.Texture != null)
            {
                this.Texture.Dispose();
                this.Texture = null;
            }
        }

        #endregion


        #region ֐iXVE`j
        
        public void Update()
        {
            //{^
            if (Pub.InputButtons[(int)VKeys.Left] > 100)
            {
                X -= 5;
            }
            if (Pub.InputButtons[(int)VKeys.Right] > 100)
            {
                X += 5;
            }
            if (Pub.InputButtons[(int)VKeys.Up] > 100)
            {
                Y -= 5;
            }
            if (Pub.InputButtons[(int)VKeys.Down] > 100)
            {
                Y += 5;
            }


            //}EX
            MouseState ms = Pub.Input.MouseGetState();
            X += ms.X / 2f;
            Y += ms.Y / 2f;


            //WCXeBbN
            JoystickState js = Pub.Input.JoystickGetState(0);
            X += js.X / 2000f;
            Y += js.Y / 2000f;

            //ʒu
            if (X < 0)                X = Pub.WindowWidth + X;
            if (X > Pub.WindowWidth)  X = X - Pub.WindowWidth;
            if (Y < 0)                Y = Pub.WindowHeight + Y;
            if (Y > Pub.WindowHeight) Y = Y - Pub.WindowHeight;

            //Փˎ
            if (this.Clashed)
            {
                if (this.ClashWait == CLASHWAIT)
                {
                    //Փˏ
                    this.Color = CLASHCOLOR;
                    this.ClashWait--;
                }
                else
                {
                    if (this.ClashWait == 0)
                    {
                        //Փˌ㏈
                        this.Color = -1;
                        this.Clashed = false;
                        this.ClashWait = CLASHWAIT; //̕
                    }
                    else
                    {
                        this.ClashWait--;
                    }
                }
            }

            //`t[i_j
            this.TotalFrame++;
        }

        public void Draw()
        {
            //cHP̕`
            Pub.Graphics.RectDraw(Pub.WindowWidth/2, 50, (int)((float)(Pub.WindowWidth - 100) / (float)HPMAX * (float)this.HP), 30, unchecked((int)0xffff0000), null);

            //LN^̕`
            Pub.Graphics.SpriteDraw((int)this.X, (int)this.Y, 0.5f, 0.5f, Scale, (float)Pub.FrameTotal / 30f, this.Color, this.Texture);
        }

        #endregion


        #region ֐ȋFJj
        #endregion
    }
}
